var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var LoginView = (function (_super) {
    __extends(LoginView, _super);
    function LoginView(isRoot) {
        _super.call(this, isRoot);
        this.bind();
        $("#username").val(this.preferences.userName || $("#username").val());
        if (this.preferences.password) {
            $("#password").val(this.preferences.password);
        }
        if (this.userData.cookieExpired) {
            Trace.showErrorMessage(Strings.CookieExpiredMessage);
        }
        window["onBack"] = window["swiped"] = window["onResume"] = window["onPause"] = function () {
        };
    }
    LoginView.prototype.demo = function () {
        LoginView._clickCount++;
        if (LoginView._clickCount >= 2) {
            $("#username").val("admin@partnerautomation15.onmicrosoft.com");
            $("#password").val("Password!1");
        }
    };
    LoginView.prototype.getInstallUrl = function () {
        if (isDebug()) {
            if (ViewModelBase.device.winPhone)
                return "http://www.windowsphone.com/s?appid=c513d238-96c6-4687-97d0-1b927f913016";
            else if (ViewModelBase.device.android)
                return "https://pacmobile-edog.azurewebsites.net/debug/O365Partner.apk";
            else if (ViewModelBase.device.iOS)
                return "itms-services://?action=download-manifest&url=https://pacmobile-edog.azurewebsites.net/debug/O365Partner.plist";
            else
                return "";
        }
        else {
            if (ViewModelBase.device.winPhone)
                return "http://www.windowsphone.com/s?appid=b6bab53e-dfac-470e-965d-c87eeeceb7c9";
            else if (ViewModelBase.device.android)
                return "https://play.google.com/store/apps/details?id=com.ms.o365partner";
            else if (ViewModelBase.device.iOS)
                return "https://itunes.apple.com/us/app/partner-admin-for-office-365/id923241552?ls=1&mt=8";
            else
                return "";
        }
    };
    LoginView.prototype.onAjaxError = function (statusCode, statusDescription, error, api, blockUI) {
        switch (statusCode) {
            case 500:
                Trace.showErrorMessage(Strings.InternalServerErrorLogin);
                return false;
            case 401:
                if (statusDescription.indexOf("0x80041084") > -1 || statusDescription.indexOf("0x80041082") > -1) {
                    Trace.showErrorMessage(Strings.PasswordNeedChange);
                    return true;
                }
                else if (statusDescription.indexOf("0x80041012") > -1 || statusDescription.indexOf("Bad username/password") > -1 || statusDescription.indexOf("Unauthorized") || statusDescription.indexOf("credentials can't be autheticated or authorized")) {
                    Trace.showErrorMessage(Strings.InvalidUsernamePasswordMessage);
                    return true;
                }
                else if (statusDescription.indexOf("0x800434d4") > -1) {
                    Trace.showErrorMessage(Strings.AppPasswordNeeded);
                    return true;
                }
                else if (statusDescription.indexOf("0x80041034") > -1) {
                    Trace.showErrorMessage(Strings.InvalidUserName);
                    return true;
                }
                else if (statusDescription.indexOf("SAML Token missing in SOAP response") > -1) {
                    Trace.showErrorMessage(Strings.InvalidUserName);
                    return true;
                }
                else if (statusDescription.indexOf("Server Unavailable") > -1) {
                    Trace.showErrorMessage(Strings.CannotReachService);
                    return true;
                }
                else if (statusDescription.indexOf("IE10") > -1) {
                    Trace.showErrorMessage(Strings.InvalidUsernamePasswordMessage);
                    return true;
                }
                else {
                    Trace.showErrorMessage(Strings.InvalidUsernamePasswordMessage);
                    return false;
                }
            case 403:
                Trace.showErrorMessage(Strings.AdminNeededMessage);
                return true;
            default:
                return _super.prototype.onAjaxError.call(this, statusCode, statusDescription, error, api, blockUI);
        }
    };
    LoginView.prototype.clickLogin = function () {
        Trace.clearErrorMessage();
        var userName = $("#username").val().trim();
        var password = $("#password").val();
        if (userName == "" || password == "") {
            Trace.showErrorMessage(Strings.InvalidUsernamePasswordMessage);
        }
        else if (userName.indexOf(" ") != -1) {
            Trace.showErrorMessage(Strings.InvalidUserNameWithSpaceMessage);
        }
        else if (userName.indexOf("@") == -1) {
            Trace.showErrorMessage(Strings.InvalidUserName);
        }
        else {
            var _this = this;
            this.asyncCheckTime();
            this.asyncRegister(userName, password);
        }
    };
    LoginView.prototype.asyncRegister = function (userName, password) {
        var replace = new Array("\\\\", '"');
        var replaceBy = new Array("\\\\", '\\"');
        for (var i = 0; i < replace.length; i++) {
            var regex = new RegExp(replace[i], "g");
            password = password.replace(regex, replaceBy[i]);
            userName = userName.replace(regex, replaceBy[i]);
        }
        if (userName != this.preferences.userName) {
            Trace.logInfo("User changed, so clear cache.");
            this.cacheLocal.clearUserDataAndPreferences();
            this.tenantData.clear();
        }
        this.preferences.userName = userName;
        this.userData.cookieExpired = false;
        var serviceParams = {
            userName: userName,
            password: password,
            domains: ""
        };
        var _this = this;
        var callback = function (response) {
            if (_this.preferences.savePassword == true) {
                _this.preferences.password = password;
            }
            else {
                _this.preferences.password = "";
            }
            if ("UserRole" in response)
                _this.userData.userRole = response.UserRole;
            if ("PartnerRole" in response)
                _this.userData.partnerRole = response.PartnerRole;
            _this.preferences.userId = response.UserId;
            _this.userData.cookie = response.RegistrationCookie;
            _this.userData.lastCookieRefreshMilliSec = (new Date()).getTime();
            _this.userData.lastPrimaryPivot = "";
            _this.userData.lastSecondPivot = "";
            _this.blockUIAjaxCount = Number.MAX_VALUE;
            _this.navigateTo("PivotView.html");
        };
        this.asyncRequest(Config.serviceURL, Config.registerTag, serviceParams, callback, null, true);
    };
    LoginView.prototype.localeChanged = function () {
        var userLocale = NativeHelper.getUserLocale();
        return (this.userData.cookie && userLocale != this.userData.locale);
    };
    LoginView._clickCount = 0;
    return LoginView;
})(ViewModelBase);
//# sourceMappingURL=LoginView.js.map