/// <reference path="Utilities.ts" />
/// <reference path="jquery.d.ts" />
/// <reference path="knockout.d.ts" />
/// <reference path="knockout.es5.d.ts" />
/// <reference path="ViewModelBase.ts" />
/// <reference path="TenantCommunication.d.ts" />

class MessagesView extends ViewModelBase {
	public static menuName = "Messages";

	public get mcMessages():MCMessage[]  {return this.tenantData.mcMessages}
	public canRefresh = true;

	constructor() {
		super();

		this.bind(); // This need to be called after fields created
	}

	public isPrimary(){
		return true;
	}

	// Event Handler
	public clickItem(message:MCMessage) {
		assert(message);
		this.tenantData.selectedMessage = message;
		this.goTo(MessageDetailsView);
		this.logEvent("Message");
	}
}

class MessageDetailsView extends ViewModelBase {
	public canRefresh = false;

	constructor() {
		super();
		this.bind(); // This need to be called after fields created
	}

	public getTitle():string{
		return this.tenantData.selectedMessage.Id;
	}

}
