var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var PivotView = (function (_super) {
    __extends(PivotView, _super);
    function PivotView() {
        _super.call(this, true);
        this.panelClosed = true;
        this.menuItems = [ClientsView, HealthView, UsersView, SupportView, MessagesView, FeedbackView, LoginView];
        this.currentPivot = null;
        this._refreshTimeoutHandle = null;
        this.initEventLogging();
        ViewModelBase.logCapptainStartActivity("SignIn");
        if (!this.userData.cookie)
            this.signOut();
        if (!this.isPartner()) {
            var index = this.menuItems.indexOf(ClientsView);
            this.menuItems.splice(index, 1);
        }
        if (this.userData.selectedIncidentId)
            this.userData.clearClientList();
        this.onHashChange();
        if (!this.currentPivot)
            this.gotoDefaultPivot();
        this.bind();
        this.loadViews();
        var _this = this;
        $("#nav-panel")["panel"]({
            beforeclose: function (event, ui) {
                _this.panelClosed = true;
            }
        });
        $("#nav-panel")["panel"]({
            beforeopen: function (event, ui) {
                _this.panelClosed = false;
            }
        });
        if (!this.cacheLocal.nativeSwipe || !Config.allowNativeSwipe) {
            $(document).on("swiperight", this.openPanel.bind(this));
            $(document).on('swipeleft', '.ui-panel-dismiss', this.closePanel.bind(this));
            $(document).on('taphold', '.ui-panel-dismiss', this.closePanel.bind(this));
        }
        else {
            window["swiped"] = this.onNativeSwipe.bind(this);
        }
        window["onResume"] = this.onResume.bind(this);
        window["onPause"] = this.onPause.bind(this);
        window["onBack"] = this.onBack.bind(this);
        window.addEventListener("hashchange", this.onHashChange.bind(this), false);
        window["setLoadedFromNotification"] = this.setLoadedFromNotification.bind(this);
        $(document).on('click', '.ui-input-clear', this.onSearchClearClick.bind(this));
        $(document).on('blur', '#search', this.onSearchBlur.bind(this));
        $(".ui-panel-dismiss").bind('touchmove', function (e) {
            e.preventDefault();
        });
    }
    Object.defineProperty(PivotView.prototype, "pincodeView", {
        get: function () {
            return this.getInstance(PincodeView);
        },
        enumerable: true,
        configurable: true
    });
    PivotView.prototype.loadViews = function () {
        var views = $(".pivotItem");
        for (var i = 0; i < views.length; i++) {
            if (views[i].children.length == 0) {
                var viewName = views[i].id;
                assert(typeof window[viewName] == "function");
                this.loadView(window[viewName]);
            }
        }
    };
    PivotView.prototype.initEventLogging = function () {
        var uid = "N/A";
        try {
            uid = CryptoJS.SHA256(this.preferences.userId).toString(CryptoJS.enc.Base64);
        }
        catch (e) {
            Trace.logError(e);
        }
        if (FlurryAgent && FlurryAgent.startSession) {
            if (isDebug() || this.isDebugUser())
                FlurryAgent.startSession("BD229KWJ3672J99CSDY4");
            else
                FlurryAgent.startSession("3D9KBP8GS4VHNWPSBKS8");
            if (isDebug())
                FlurryAgent.setRequestInterval(5);
            FlurryAgent.setAppVersion(ViewModelBase.getAppVersion());
            FlurryAgent.setUserId(uid);
            Trace.logInfo("flurry inited");
        }
        if (capptain) {
            if (isDebug() || this.isDebugUser())
                capptain.appId = "opa000002";
            else
                capptain.appId = "opa000001";
            var appInfos = {
                userid: uid,
                OS: ViewModelBase.getDeviceOS(),
                userAgent: navigator.userAgent
            };
            ViewModelBase.logCapptainAppInfo(appInfos);
            Trace.logInfo("capptain inited");
        }
    };
    PivotView.prototype.isDebugUser = function () {
        var debugUsers = [
            "d12bc342-9a92-44e1-bd69-5948519c8487",
            "c3374beb-bd67-48db-8bf9-fb2842f72f66",
            "0777fab6-8163-40a8-aeeb-67cbbac709ca",
            "da5aa0a6-447a-4218-91c8-2d71dd4db7cf"
        ];
        return debugUsers.indexOf(this.preferences.userId) > -1;
    };
    PivotView.prototype.onSearchClearClick = function () {
        this.currentPivot.onSearchClearClick();
    };
    PivotView.prototype.onSearchBlur = function () {
        this.currentPivot.onSearchBlur();
    };
    PivotView.prototype.goBack = function () {
        if (window.history.length >= 2) {
            Trace.clearErrorMessage();
            window.history.back();
            return window.location.href;
        }
        else {
            return "";
        }
    };
    PivotView.prototype.getTitle = function () {
        if (this.currentPivot.getTitle())
            return this.currentPivot.getTitle();
        else
            return ViewModelBase.capitalize(this.currentPivot.getClassName().replace("View", ""));
    };
    PivotView.prototype.getSecondaryTitle = function () {
        if (this.currentPivot.getSecondaryTitle())
            return this.currentPivot.getSecondaryTitle();
        else {
            if (this.currentPivot instanceof ClientsView || this.currentPivot instanceof SettingsView || this.currentPivot instanceof SyncView || this.currentPivot instanceof FeedbackView || this.currentPivot instanceof PincodeView)
                return "";
            else if (this.tenantData.isAOBO && this.tenantData.companyInfo)
                return this.tenantData.companyInfo.DisplayName;
            else
                return this.getUserDomain();
        }
    };
    PivotView.prototype.getUserDomain = function () {
        return this.preferences.userName.toLowerCase().split("@")[1];
    };
    PivotView.prototype.getRightBtn = function () {
        return this.currentPivot.getRightBtn();
    };
    PivotView.prototype.clickRightBtn = function () {
        this.currentPivot.clickRightBtn();
    };
    PivotView.prototype.getLeftBtn = function () {
        return this.currentPivot.getLeftBtn();
    };
    PivotView.prototype.clickLeftBtn = function () {
        this.currentPivot.clickLeftBtn();
    };
    PivotView.prototype.onHashChange = function () {
        var hash = window.location.hash.split("&")[0].split("?")[0];
        hash = hash.replace("#", "");
        if (hash) {
            this.goToPivot(hash);
        }
        this.closePanel();
    };
    PivotView.prototype.setLoadedFromNotification = function () {
    };
    PivotView.prototype.onResume = function () {
        this.pincodeView.onBlur();
    };
    PivotView.prototype.onPause = function () {
        this.pincodeView.onBlur();
    };
    PivotView.prototype.onBack = function () {
        return this.currentPivot.goBack();
    };
    PivotView.prototype.onNativeSwipe = function (toRight) {
        this.setPanel(toRight);
    };
    PivotView.prototype.closePanel = function () {
        this.setPanel(false);
    };
    PivotView.prototype.openPanel = function () {
        this.setPanel(true);
    };
    PivotView.prototype.setPanel = function (open) {
        if (!$("#nav-panel")["panel"])
            return;
        if (open && this.currentPivot.menuEnabled) {
            $("#nav-panel")["panel"]("open");
        }
        else {
            $("#nav-panel")["panel"]("close");
        }
    };
    PivotView.prototype.clickMenuItem = function (viewClass) {
        var id = this.getIconName(viewClass);
        var className = this.getClassName(viewClass);
        switch (viewClass) {
            case LoginView:
                this.logEvent("SignOut");
                this.signOut();
                break;
            case ClientsView:
                if (this.userData.selectedIncidentId) {
                    this.userData.clearClientList();
                    if (this.currentPivot instanceof ClientsView)
                        this.getInstance(ClientsView).onReload();
                }
            default:
                this.goTo(viewClass);
                this.logEvent(id);
        }
        $("#nav-panel")["panel"]("close");
    };
    PivotView.prototype.getMenuItemClass = function (viewClass) {
        return this.getIconClass(this.getIconName(viewClass));
    };
    PivotView.prototype.getIconName = function (viewClass) {
        if (viewClass == LoginView)
            return "Sign out";
        else
            return this.getClassName(viewClass).replace("View", "");
    };
    PivotView.prototype.redirectToFeedbackPage = function () {
        this.goTo(FeedbackView);
    };
    PivotView.prototype.getMenuImageURL = function (pivot) {
        return "images/" + pivot.toLowerCase() + ".png";
    };
    PivotView.prototype.getMenuItemBackgroundColor = function () {
        return "#58595b";
    };
    PivotView.prototype.gotoLastPivot = function () {
        if (this.userData.lastPrimaryPivot)
            this.goToPivot(this.userData.lastPrimaryPivot);
        else
            this.gotoDefaultPivot();
    };
    PivotView.prototype.gotoDefaultPivot = function () {
        if (this.isPartner())
            this.goTo(ClientsView);
        else
            this.goTo(HealthView);
    };
    PivotView.prototype.goToPivot = function (viewName) {
        Trace.logVerbose("try go to " + viewName);
        assert(viewName);
        if (typeof window[viewName] == "function") {
            this.goTo(window[viewName]);
        }
    };
    PivotView.prototype.goTo = function (viewClass) {
        var viewName = this.getClassName(viewClass);
        if (this.currentPivot instanceof viewClass) {
            Trace.logVerbose("skipped " + viewName + " since no pivot change");
            return;
        }
        ViewModelBase.logCapptainEndActivity();
        ViewModelBase.logCapptainStartActivity(viewName);
        Trace.clearErrorMessage();
        if (viewClass == ClientsView) {
            if (this.tenantData.isAOBO)
                this.tenantData.clear();
        }
        var newPivot = this.getInstance(viewClass, true);
        if (newPivot.isPrimary()) {
            this.userData.lastPrimaryPivot = viewName;
            this.userData.lastSecondPivot = "";
        }
        else {
            this.userData.lastSecondPivot = viewName;
        }
        if (this.currentPivot && this.currentPivot.skipHistory)
            window.location.replace(window.location.href.split('#')[0] + '#' + viewName);
        else
            window.location.hash = viewName;
        this.cacheLocal.save();
        $(".ui-pivot-items").show();
        $(".ui-pivot-items").children(".pivotItem.current").removeClass("current");
        var current = $(".ui-pivot-items").children("#" + viewName).addClass("current");
        if (this.currentPivot && newPivot.pageAnimation())
            current.css({ marginLeft: (-window.outerWidth), opacity: .5 }).animate({ marginLeft: "0px", opacity: 1 }, 200, 'linear');
        else
            current.animate({ marginLeft: "0px", opacity: 1 });
        $.mobile.silentScroll(0);
        this.currentPivot = newPivot;
        this.refreshIfNeeded();
        Trace.logVerbose("Went to " + viewName);
    };
    PivotView.prototype.asyncSearchServiceRequests = function () {
        var serviceParams = {
            lastCookie: this.userData.cookie,
            tenantDomains: []
        };
        if (this.tenantData.isAOBO)
            serviceParams.tenantDomains.push(this.tenantData.companyInfo.InitialDomain);
        var callback = function (response) {
            response.forEach(function (sr) {
                ko.track(sr);
            });
            this.tenantData.filteredSRs = response.sort(function (a, b) {
                return ViewModelBase.getDate(a.CreatedOn).getTime() - ViewModelBase.getDate(b.CreatedOn).getTime();
            });
        };
        this.tenantData.lastEventRefreshMilliSec = (new Date()).getTime();
        this.asyncRequest(Config.serviceURL, Config.searchServiceRequestsTag, serviceParams, callback);
    };
    PivotView.prototype.asyncGetServiceInfo = function () {
        var serviceParams = {
            lastCookie: this.userData.cookie,
            tenantDomains: this.isAOBO() ? [this.tenantData.companyInfo.InitialDomain] : [],
            locale: this.userData.locale
        };
        var _this = this;
        var callback = function (response) {
            if (response && response.length) {
                _this.tenantData.services = response;
                _this.asyncGetEventsInfo(0 /* Full */);
            }
        };
        this.asyncRequest(Config.serviceURL, this.isAOBO() ? Config.getServiceInformationForTenantDomainsTag : Config.getServiceInformationTag, serviceParams, callback);
    };
    PivotView.prototype.asyncGetEventsInfo = function (eventType) {
        var serviceParams = {
            lastCookie: this.userData.cookie,
            preferredEventTypes: [eventType],
            tenantDomains: this.isAOBO() ? [this.tenantData.companyInfo.InitialDomain] : [],
            pastDays: 1,
            locale: this.userData.locale
        };
        var _this = this;
        var callback = function (response) {
            if (!_this.isAOBO())
                var events = response.Events;
            else if (response.EventsByTenantDomain && response.EventsByTenantDomain[0])
                events = response.EventsByTenantDomain[0].Value;
            if (events) {
                if (eventType == 2 /* MC */) {
                    _this.tenantData.mcMessages = events.sort(function (m1, m2) {
                        return ViewModelBase.getDate(m2.StartTime).getTime() - ViewModelBase.getDate(m1.StartTime).getTime();
                    });
                }
                else {
                    events.forEach(function (e) {
                        e.AffectedTenantCount = -1;
                    });
                    _this.tenantData.incidents = events.map(HealthView.toServiceIncident);
                }
            }
        };
        this.asyncRequest(Config.serviceURL, this.isAOBO() ? Config.getEventsForTenantDomainsTag : Config.getEventstag, serviceParams, callback);
    };
    PivotView.prototype.asyncGetEventsForPartner = function () {
        var client = this.tenantData.isAOBO;
        var serviceParams = {
            lastCookie: this.userData.cookie,
            pastDays: 7,
            locale: this.userData.locale
        };
        var _this = this;
        var callback = function (response) {
            _this.userData.clientIncidents = response.map(HealthView.toServiceIncident);
        };
        this.asyncRequest(Config.serviceURL, Config.getEventsForPartnerTag, serviceParams, callback);
    };
    PivotView.prototype.onSearchSubmit = function (e) {
        var searchString = $("#search", e).val().trim();
        $('#search').blur();
        Trace.clearErrorMessage();
        this.currentPivot.search(searchString, true);
        return false;
    };
    PivotView.prototype.showProgress = function () {
        if (this.currentPivot.canRefresh && this.ajaxCount)
            return true;
        else
            return !!this.currentPivot.ajaxCount;
    };
    PivotView.prototype.GetLastRefreshTimeText = function () {
        var minutes = this.getCurrentRefreshMinutes();
        var lastRefreshPrefix = "Last synced ";
        if (this.failedAjaxCount)
            lastRefreshPrefix += "failed ";
        if (minutes > 30) {
            return lastRefreshPrefix + "more than 30 minutes ago";
        }
        else {
            return lastRefreshPrefix + minutes + " minutes ago";
        }
    };
    PivotView.prototype.refreshIfNeeded = function () {
        if (this.ajaxCount) {
            Trace.logInfo("skip refresh since it is in progress");
            return;
        }
        var minutes = this.getCurrentRefreshMinutes();
        if (this._refreshTimeoutHandle != null) {
            clearTimeout(this._refreshTimeoutHandle);
        }
        if (this.preferences.refreshMinutes != 0 && minutes > this.preferences.refreshMinutes) {
            Trace.clearErrorMessage();
            this.refresh();
        }
        this._refreshTimeoutHandle = window.setTimeout(this.refreshIfNeeded.bind(this), 60000);
    };
    PivotView.prototype.refresh = function () {
        this.asyncCheckTime();
        this.asyncSearchServiceRequests();
        this.asyncGetServiceInfo();
        if (this.isPartnerNotAOBO()) {
            this.asyncGetEventsForPartner();
        }
        if (!this.tenantData.mcMessages.length)
            this.asyncGetEventsInfo(2 /* MC */);
        this.failedAjaxCount = 0;
    };
    PivotView.prototype._getMiddle = function (start, end, factor) {
        return Math.floor(start + (end - start) * factor);
    };
    return PivotView;
})(ViewModelBase);
//# sourceMappingURL=PivotView.js.map