var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var SupportView = (function (_super) {
    __extends(SupportView, _super);
    function SupportView() {
        _super.call(this);
        this.bind();
    }
    SupportView.prototype.isPrimary = function () {
        return true;
    };
    SupportView.prototype.clickServiceRequest = function (id) {
        this.tenantData.selectedSR = id;
        this.goTo(ServiceRequestView);
        this.logEvent("SR");
    };
    SupportView.prototype.getTicketClass = function (status) {
        if (status != "Open")
            status = "Closed";
        return this.getIconClass(status);
    };
    SupportView.menuName = "Support";
    return SupportView;
})(ViewModelBase);
var ServiceRequestView = (function (_super) {
    __extends(ServiceRequestView, _super);
    function ServiceRequestView() {
        _super.call(this);
        this.canRefresh = false;
        this.isEdit = false;
        this.bind();
    }
    ServiceRequestView.prototype.onReload = function () {
        this.isEdit = false;
        this.serviceRequest = this.tenantData.selectedSR;
        assert(this.serviceRequest, "selectedSR is null");
        ko.track(this.serviceRequest);
        this.asyncGetServiceRequest(this.serviceRequest);
    };
    ServiceRequestView.prototype.getTitle = function () {
        return this.tenantData.selectedSR.ServiceRequestNumber;
    };
    ServiceRequestView.prototype.getServiceRequest = function () {
        return this.tenantData.selectedSR;
    };
    ServiceRequestView.prototype.getRightBtn = function () {
        if (!this.isEdit && this.editSRPermitted())
            return this.getIconClass("edit");
        else
            return "hidden";
    };
    ServiceRequestView.prototype.editSRPermitted = function () {
        return (!this.isAOBO() || this.userData.partnerRole == 1 /* FullAdministration */);
    };
    ServiceRequestView.prototype.clickRightBtn = function () {
        this.isEdit = true;
        this.logEvent("EditSR");
    };
    ServiceRequestView.prototype.reopenSR = function () {
        this.logEvent("ReopenSR");
        this.asyncUpdateServiceRequest(this.serviceRequest, "Open", "");
    };
    ServiceRequestView.prototype.closeSR = function () {
        this.logEvent("CloseSR");
        this.asyncUpdateServiceRequest(this.serviceRequest, "Closed", "");
    };
    ServiceRequestView.prototype.addNote = function () {
        this.logEvent("AddSRNote");
        var note = $("#newNote").val();
        if (note)
            this.asyncUpdateServiceRequest(this.serviceRequest, "Unknown", note);
        else
            Trace.showErrorMessage(Strings.EmptyMessage);
    };
    ServiceRequestView.prototype.asyncGetServiceRequest = function (sr) {
        var serviceParams = {
            lastCookie: this.userData.cookie,
            referenceNumber: sr.ServiceRequestNumber
        };
        var _this = this;
        var callback = function (response) {
            if (response) {
                if (response.Notes && response.Notes.length) {
                    response.Notes = response.Notes.sort(ServiceRequestView.compareNote);
                }
                sr.Details = response;
                _this.serviceRequest = _this.serviceRequest;
            }
        };
        this.asyncRequest(Config.serviceURL, Config.getServiceRequestTag, serviceParams, callback);
    };
    ServiceRequestView.compareNote = function (a, b) {
        return ViewModelBase.getDate(b.CreatedDateTime).getTime() - ViewModelBase.getDate(a.CreatedDateTime).getTime();
    };
    ServiceRequestView.prototype.asyncUpdateServiceRequest = function (sr, status, note) {
        var serviceParams = {
            lastCookie: this.userData.cookie,
            referenceNumber: sr.ServiceRequestNumber,
            status: status,
            note: note
        };
        var _this = this;
        var callback = function (response) {
            $("#newNote").val("");
            if (response) {
                if (response.Notes && response.Notes.length) {
                    response.Notes = response.Notes.sort(ServiceRequestView.compareNote);
                }
                sr.Details = response;
            }
            if (status != "Unknown") {
                sr.SRStatus = status;
            }
            else {
                _this.isEdit = false;
            }
        };
        this.asyncRequest(Config.serviceURL, Config.updateServiceRequestTag, serviceParams, callback, null, true);
    };
    return ServiceRequestView;
})(ViewModelBase);
//# sourceMappingURL=SupportView.js.map