/// <reference path="./knockout.d.ts" />
interface KnockoutStatic {
	track(obj: any, propertyNames?: Array<string>): any;
	defineProperty(obj: any, propertyName: string, evaluator: Function): any;
	defineProperty(obj: any, propertyName: string, options: KnockoutDefinePropertyOptions): any;
	getObservable(obj: any, propertyName: string): KnockoutObservable<any>;
	valueHasMutated(obj: any, propertyName: string): void;
}

interface KnockoutDefinePropertyOptions {
	get(): any;
	set?(value: any): void;
}

interface Array<T> {
	replace(item1: T, item2: T): void;

	remove(item): T[];
	removeAll(items: T[]): T[];
	removeAll(): T[];

	destroy(item: T): void;
	destroyAll(items: T[]): void;
	destroyAll(): void;
}
